'use strict';

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('swatchjs-koa-middleware'),
    response = _require.response;

var execHandler = require('./handler');
var opsSchema = require('./schemas/ops');
var validator = require('./schemas/validator');

var validate = validator(opsSchema);

function batch(model) {
  var handleOp = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(op) {
      var methodHandler, result, error;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(op.method in methods)) {
                _context.next = 6;
                break;
              }

              methodHandler = methods[op.method];
              _context.next = 4;
              return methodHandler.call(this, op.args);

            case 4:
              result = _context.sent;
              return _context.abrupt('return', result);

            case 6:
              error = new Error('invalid_method');
              return _context.abrupt('return', response.error.call(this, error));

            case 8:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function handleOp(_x) {
      return _ref.apply(this, arguments);
    };
  }();

  var batchHandler = function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(ops) {
      var _this = this;

      var that, results;
      return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.prev = 0;

              validate(ops);
              _context3.next = 7;
              break;

            case 4:
              _context3.prev = 4;
              _context3.t0 = _context3['catch'](0);
              throw new Error('invalid_request');

            case 7:
              that = this;
              _context3.next = 10;
              return _promise2.default.all(ops.map(function () {
                var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(op) {
                  var r;
                  return _regenerator2.default.wrap(function _callee2$(_context2) {
                    while (1) {
                      switch (_context2.prev = _context2.next) {
                        case 0:
                          _context2.next = 2;
                          return handleOp.call(that, op);

                        case 2:
                          r = _context2.sent;
                          return _context2.abrupt('return', r);

                        case 4:
                        case 'end':
                          return _context2.stop();
                      }
                    }
                  }, _callee2, _this);
                }));

                return function (_x3) {
                  return _ref3.apply(this, arguments);
                };
              }()));

            case 10:
              results = _context3.sent;
              return _context3.abrupt('return', results);

            case 12:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, this, [[0, 4]]);
    }));

    return function batchHandler(_x2) {
      return _ref2.apply(this, arguments);
    };
  }();

  var methods = {};
  model.forEach(function (method) {
    methods[method.name] = execHandler(method);
  });

  return batchHandler;
}

module.exports = batch;