'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var compose = require('koa-compose');

var _require = require('swatchjs-koa-middleware'),
    response = _require.response;

var wrapper = require('./wrapper');

function execHandler(method) {
  var handle = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(params) {
      var localCtx, allMiddleware, allHandlers;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              // Create a mock koaCtx that is empty and doesnt share state
              //  All state should have been set on the swatchCtx by the
              //  batch endpoints middleware, so each sub-operation we try
              //  to handle should get its own swatchCtx with headers/etc
              localCtx = {
                body: {},
                swatchCtx: (0, _assign2.default)({}, this)
              };
              _context.prev = 1;

              // Run validation on the specific endpoint before handler
              method.validate(localCtx, params);

              // Run all swatchJs middleware for the endpoint before handler
              allMiddleware = method.metadata.middleware.map(wrapper.wrapMiddleware);
              allHandlers = allMiddleware.concat(wrapper.wrapHandler(method.handle));

              // Compose all middleware with the final handler and execute
              //  At the end we return the `localCtx.body` result that was set
              //  since each operation independently returns a result object

              _context.next = 7;
              return compose(allHandlers)(localCtx);

            case 7:
              return _context.abrupt('return', localCtx.body);

            case 10:
              _context.prev = 10;
              _context.t0 = _context['catch'](1);
              return _context.abrupt('return', response.error.call(localCtx.swatchCtx, _context.t0));

            case 13:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this, [[1, 10]]);
    }));

    return function handle(_x) {
      return _ref.apply(this, arguments);
    };
  }();

  return handle;
}

module.exports = execHandler;