'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _require = require('swatchjs-koa-middleware'),
    response = _require.response;

function wrapHandler(fn) {
  var handlerWrapper = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(koaCtx) {
      var swatchCtx, result;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              swatchCtx = koaCtx.swatchCtx;
              _context.prev = 1;
              _context.next = 4;
              return fn(koaCtx);

            case 4:
              result = _context.sent;

              koaCtx.body = response.success.call(swatchCtx, result);
              _context.next = 11;
              break;

            case 8:
              _context.prev = 8;
              _context.t0 = _context['catch'](1);

              koaCtx.body = response.error.call(swatchCtx, _context.t0);

            case 11:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, this, [[1, 8]]);
    }));

    return function handlerWrapper(_x) {
      return _ref.apply(this, arguments);
    };
  }();

  return handlerWrapper;
}

// Generic function wraps `fn` as Swatch KOA middleware
//  `fn` signature accepts Swatch ctx + next callback
//  Catches any errors and sets an error response
function wrapMiddleware(fn) {
  var middlewareWrapper = function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(koaCtx, next) {
      var swatchCtx;
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              swatchCtx = koaCtx.swatchCtx;
              _context2.prev = 1;
              _context2.next = 4;
              return fn(swatchCtx, next);

            case 4:
              _context2.next = 9;
              break;

            case 6:
              _context2.prev = 6;
              _context2.t0 = _context2['catch'](1);

              // Auth error should turn into failure response
              koaCtx.body = response.error.call(swatchCtx, _context2.t0);

            case 9:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, this, [[1, 6]]);
    }));

    return function middlewareWrapper(_x2, _x3) {
      return _ref2.apply(this, arguments);
    };
  }();

  return middlewareWrapper;
}

module.exports = {
  wrapHandler: wrapHandler,
  wrapMiddleware: wrapMiddleware
};